Unit IIS6R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, IIS5R_p, UTII10_p;

procedure IIS6R(var F :Array of Real; var X :Array of Real;
                NX :Integer; var Y :Array of Real;
                NY :Integer; LX :Integer; LY :Integer;
                var C :Array of Real; var WK :Array of Real;
                var IERR :Integer);

implementation

procedure IIS6R(var F :Array of Real; var X :Array of Real;
                NX :Integer; var Y :Array of Real;
                NY :Integer; LX :Integer; LY :Integer;
                var C :Array of Real; var WK :Array of Real;
                var IERR :Integer);
var
I,IPL,J,JER,K,L,LC,LM1,LW,NI,LCK,LWK,IWK :Integer;
D,DX,DXX,DY,DYY :Real;
XL :Array [0..3] of Real;
YL :Array [0..3] of Real;
A :Array [0..15] of Real;
const
ZERO :Real = 0.0;
P25 :Real = 0.25;
P75 :Real = 0.75;
ONE :Real = 1.0;
THREE :Real = 3.000;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17;
begin
{   DATA  FORTRAN  }
A[0] := 3.0;
A[1] := -19.0;
A[2] := 32.0;
A[3] := -16.0;
A[4] := 0.0;
A[5] := 24.0;
A[6] := -56.0;
A[7] := 32.0;
A[8] := 0.0;
A[9] := -8.0;
A[10] := 40.0;
A[11] := -32.0;
A[12] := 0.0;
A[13] := 3.0;
A[14] := -16.0;
A[15] := 16.0;
IERR := 0;
if ( NX < 2 ) 
 then goto _10;
if ( NY < 2 ) 
 then goto _11;
NI := NX-1;
for I:=1 to NI do
 begin
  D := X[I+0]-X[I-1];
  if ( D <= ZERO ) 
   then goto _12;
_1:
 end;
NI := NY-1;
for I:=1 to NI do
 begin
  D := Y[I+0]-Y[I-1];
  if ( D <= ZERO ) 
   then goto _13;
_2:
 end;
if ( LX < 1 ) or ( LX >= NX ) 
 then goto _14;
if ( LY < 1 ) or ( LY >= NY ) 
 then goto _15;
DX := X[LX+0]-X[LX-1];
DY := Y[LY+0]-Y[LY-1];
XL[0] := X[LX-1];
XL[1] := X[LX-1]+P25*DX;
XL[2] := X[LX-1]+P75*DX;
XL[3] := X[LX+0];
YL[1] := Y[LY-1]+P25*DY;
YL[0] := Y[LY-1];
YL[2] := Y[LY-1]+P75*DY;
YL[3] := Y[LY+0];
IWK := 4*Max0(4,NY)+1;
JER := 111111;
IIS5R(F,X,NX,Y,NY,XL,4,YL,4,WK[0],WK[IWK-1],JER);
L := 1;
while ( L<=13 ) do
 begin
  LM1 := L-1;
  for I:=1 to 4 do
   begin
    IPL := I+LM1;
    C[IPL-1] := ZERO;
    for J:=1 to 4 do
     begin
      C[IPL-1] := C[IPL-1]+A[(I-1)+(J-1)*4]*WK[J+LM1-1];
_3:
     end;
   end;
_4:
  inc(L,4);
 end;
for L:=1 to 16 do
 begin
  WK[L-1] := C[L-1]/THREE;
  C[L-1] := ZERO;
  if ( L <= 4 ) 
   then C[L-1] := WK[L-1];
_5:
 end;
LC := 0;
for I:=2 to 4 do
 begin
  LC := LC+4;
  LW := -4;
  for J:=1 to 4 do
   begin
    LW := LW+4;
    for K:=1 to 4 do
     begin
      LCK := LC+K;
      LWK := LW+K;
      C[LCK-1] := C[LCK-1]+A[(I-1)+(J-1)*4]*WK[LWK-1];
_6:
     end;
   end;
_7:
 end;
L := 0;
DYY := ONE;
for J:=1 to 4 do
 begin
  DXX := ONE;
  for I:=1 to 4 do
   begin
    L := L+1;
    C[L-1] := C[L-1]*DXX*DYY;
    if ( L >= 5 ) 
     then C[L-1] := C[L-1]/THREE;
    DXX := DXX/DX;
_8:
   end;
  DYY := DYY/DY;
_9:
 end;
goto _17;
_10:
IERR := 65;
goto _16;
_11:
IERR := 66;
goto _16;
_12:
IERR := 67;
goto _16;
_13:
IERR := 68;
goto _16;
_14:
IERR := 69;
goto _16;
_15:
IERR := 70;
_16:
UTII10(IERR,6);
_17:
end;

end.
